//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AAE7FBD028E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AAE7FBD028E.cm

//## begin module%4AAE7FBD028E.cp preserve=no
//## end module%4AAE7FBD028E.cp

//## Module: PlotPkg%4AAE7FBD028E; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotPkg.h

#ifndef PLOTPKG_H
#define PLOTPKG_H 1

//## begin module%4AAE7FBD028E.additionalIncludes preserve=no
//## end module%4AAE7FBD028E.additionalIncludes

//## begin module%4AAE7FBD028E.includes preserve=yes
#include <xsTypes.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <list>
//## end module%4AAE7FBD028E.includes


class PlotPane;

//## begin module%4AAE7FBD028E.declarations preserve=no
//## end module%4AAE7FBD028E.declarations

//## begin module%4AAE7FBD028E.additionalDeclarations preserve=yes
//## end module%4AAE7FBD028E.additionalDeclarations


//## begin PlotPkg%4AAE8A700152.preface preserve=yes
//## end PlotPkg%4AAE8A700152.preface

//## Class: PlotPkg%4AAE8A700152
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class PlotPkg 
{
  //## begin PlotPkg%4AAE8A700152.initialDeclarations preserve=yes
  //## end PlotPkg%4AAE8A700152.initialDeclarations

  public:
    //## Destructor (generated)
      virtual ~PlotPkg();


    //## Other Operations (specified)
      //## Operation: setDevice%4AC66C080164
      virtual void setDevice (const string& device, bool splashOn = true) = 0;

      //## Operation: BADVALUE%4B1D55270040
      virtual Real BADVALUE () const;

      //## Operation: addPane%4AE8B399034E
      //	PlotPkg will take ownership of the PlotPane object that
      //	is passed here.  Function returns the number of Panes
      //	loaded (after this one is added).
      //## Exceptions: ()
      size_t addPane (PlotPane* pane) throw ();

      //## Operation: clearPanes%4AE8B53C0360
      //## Exceptions: ()
      void clearPanes () throw ();

      //## Operation: display%4AEB62540157
      //	Template Method wrapper for performing conversion of Plot
      //	Pane information to package-dependent display.
      void display ();

      //## Operation: flushHardcopy%4B59C4AB0358
      //	Function for performing any optional buffer flushing and
      //	other cleanup tasks.  PlotDirector calls this one time
      //	after all other display functions have been performed,
      //	AND as part of its makePlot exception handling cleanup.
      virtual void flushHardcopy ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: deviceName%4AC66BD7027F
      const string& deviceName () const;
      void deviceName (const string& value);

      //## Attribute: shareXaxis%4AF454AC02FB
      //	If true, this tells PlotPkg that it may use the same
      //	x-axis scale (including ticks) for all plots within a
      //	vertical stack.
      const std::vector<bool>& shareXaxis () const;
      void shareXaxis (const std::vector<bool>& value);

      //## Attribute: panesInStack%4AF483590262
      const std::vector<size_t>& panesInStack () const;
      void panesInStack (const std::vector<size_t>& value);

      //## Attribute: userCommands%4B032520001A
      //	A non-owning pointer, this points to the list of
      //	additional commands the user may have entered.  Leave it
      //	up to PlotPkg subclass to determine what (if anything)
      //	to do with it.
      const std::list<string>* userCommands () const;
      void setUserCommands (const std::list<string>* value);

      //## Attribute: isInteractive%4B0D9A7A0096
      bool isInteractive () const;
      void isInteractive (bool value);

      //## Attribute: vectorCategories%4AF98D27003E
      static const std::vector<PlotStyle::VectorCategory>& vectorCategories ();

    // Additional Public Declarations
      //## begin PlotPkg%4AAE8A700152.public preserve=yes
      //## end PlotPkg%4AAE8A700152.public

  protected:
    //## Constructors (generated)
      PlotPkg();

    //## Get and Set Operations for Associations (generated)

      //## Association: XSPlot::Plot::<unnamed>%4AE8B18400AD
      //## Role: PlotPkg::plotPanes%4AE8B1850017
      const std::vector<PlotPane*>& plotPanes () const;

    // Additional Protected Declarations
      //## begin PlotPkg%4AAE8A700152.protected preserve=yes
      //## end PlotPkg%4AAE8A700152.protected

  private:
    //## Constructors (generated)
      PlotPkg(const PlotPkg &right);

    //## Assignment Operation (generated)
      PlotPkg & operator=(const PlotPkg &right);


    //## Other Operations (specified)
      //## Operation: doInitialize%4B041907017C
      //	Wrapper for any operations or plotting commands that
      //	should be issued at the start, independent of the
      //	individual PlotPanes.
      virtual void doInitialize ();

      //## Operation: setPanePosition%4B0419EC0263
      virtual void setPanePosition (const size_t iPane);

      //## Operation: setPaneRanges%4B041A4E0297
      virtual void setPaneRanges (const size_t iPane);

      //## Operation: setPaneStyles%4B041A7C01E1
      virtual void setPaneStyles (const size_t iPane);

      //## Operation: setPaneLabels%4B041AAA01FA
      virtual void setPaneLabels (const size_t iPane);

      //## Operation: setPaneLineIDs%4B5F5DB900F7
      virtual void setPaneLineIDs (const size_t iPane);

      //## Operation: setContourCmds%4B55DF4E0145
      //	This will be called only if pane is doing a 2-D contour
      //	plot.  It is intended to issue any additional
      //	package-specific commands required by the contour plot.
      virtual void setContourCmds (const size_t iPane);

      //## Operation: doDisplay%4B041AE3006B
      //	This is the only function in the display() Template
      //	Method which MUST BE OVERRIDDEN.  It is where any final
      //	plotting commands should be issued, and where the
      //	display is ultimately performed.
      virtual void doDisplay () = 0;

      //## Operation: calculatePanePositions%4B0B0D1902BF
      //	This calculates the positions of each pane in generic
      //	coordinates:  the lower-left and upper-right positions
      //	of the largest allowed single-pane plot are by
      //	definition (0,0) and (1,1).  The actual plotting
      //	packages are free to use or ignore the results of these
      //	calculations within their setPanePosition functions.
      void calculatePanePositions ();

    // Additional Private Declarations
      //## begin PlotPkg%4AAE8A700152.private preserve=yes
      //## end PlotPkg%4AAE8A700152.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin PlotPkg::deviceName%4AC66BD7027F.attr preserve=no  public: string {U} 
      string m_deviceName;
      //## end PlotPkg::deviceName%4AC66BD7027F.attr

      //## begin PlotPkg::shareXaxis%4AF454AC02FB.attr preserve=no  public: std::vector<bool> {U} 
      std::vector<bool> m_shareXaxis;
      //## end PlotPkg::shareXaxis%4AF454AC02FB.attr

      //## begin PlotPkg::panesInStack%4AF483590262.attr preserve=no  public: std::vector<size_t> {U} 
      std::vector<size_t> m_panesInStack;
      //## end PlotPkg::panesInStack%4AF483590262.attr

      //## begin PlotPkg::userCommands%4B032520001A.attr preserve=no  public: const std::list<string>* {U} 
      const std::list<string>* m_userCommands;
      //## end PlotPkg::userCommands%4B032520001A.attr

      //## begin PlotPkg::isInteractive%4B0D9A7A0096.attr preserve=no  public: bool {U} 
      bool m_isInteractive;
      //## end PlotPkg::isInteractive%4B0D9A7A0096.attr

      //## begin PlotPkg::vectorCategories%4AF98D27003E.attr preserve=no  public: static std::vector<PlotStyle::VectorCategory> {U} std::vector<PlotStyle::VectorCategory>()
      static std::vector<PlotStyle::VectorCategory> s_vectorCategories;
      //## end PlotPkg::vectorCategories%4AF98D27003E.attr

    // Data Members for Associations

      //## Association: XSPlot::Plot::<unnamed>%4AE8B18400AD
      //## begin PlotPkg::plotPanes%4AE8B1850017.role preserve=no  protected: PlotPane {1..n -> 1RFHgN}
      std::vector<PlotPane*> m_plotPanes;
      //## end PlotPkg::plotPanes%4AE8B1850017.role

    // Additional Implementation Declarations
      //## begin PlotPkg%4AAE8A700152.implementation preserve=yes
      //## end PlotPkg%4AAE8A700152.implementation

};

//## begin PlotPkg%4AAE8A700152.postscript preserve=yes
//## end PlotPkg%4AAE8A700152.postscript

// Class PlotPkg 


//## Other Operations (inline)
inline size_t PlotPkg::addPane (PlotPane* pane) throw ()
{
  //## begin PlotPkg::addPane%4AE8B399034E.body preserve=yes
   m_plotPanes.push_back(pane);
   return m_plotPanes.size();
  //## end PlotPkg::addPane%4AE8B399034E.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& PlotPkg::deviceName () const
{
  //## begin PlotPkg::deviceName%4AC66BD7027F.get preserve=no
  return m_deviceName;
  //## end PlotPkg::deviceName%4AC66BD7027F.get
}

inline void PlotPkg::deviceName (const string& value)
{
  //## begin PlotPkg::deviceName%4AC66BD7027F.set preserve=no
  m_deviceName = value;
  //## end PlotPkg::deviceName%4AC66BD7027F.set
}

inline const std::vector<bool>& PlotPkg::shareXaxis () const
{
  //## begin PlotPkg::shareXaxis%4AF454AC02FB.get preserve=no
  return m_shareXaxis;
  //## end PlotPkg::shareXaxis%4AF454AC02FB.get
}

inline void PlotPkg::shareXaxis (const std::vector<bool>& value)
{
  //## begin PlotPkg::shareXaxis%4AF454AC02FB.set preserve=no
  m_shareXaxis = value;
  //## end PlotPkg::shareXaxis%4AF454AC02FB.set
}

inline const std::vector<size_t>& PlotPkg::panesInStack () const
{
  //## begin PlotPkg::panesInStack%4AF483590262.get preserve=no
  return m_panesInStack;
  //## end PlotPkg::panesInStack%4AF483590262.get
}

inline void PlotPkg::panesInStack (const std::vector<size_t>& value)
{
  //## begin PlotPkg::panesInStack%4AF483590262.set preserve=no
  m_panesInStack = value;
  //## end PlotPkg::panesInStack%4AF483590262.set
}

inline const std::list<string>* PlotPkg::userCommands () const
{
  //## begin PlotPkg::userCommands%4B032520001A.get preserve=no
  return m_userCommands;
  //## end PlotPkg::userCommands%4B032520001A.get
}

inline void PlotPkg::setUserCommands (const std::list<string>* value)
{
  //## begin PlotPkg::setUserCommands%4B032520001A.set preserve=no
  m_userCommands = value;
  //## end PlotPkg::setUserCommands%4B032520001A.set
}

inline bool PlotPkg::isInteractive () const
{
  //## begin PlotPkg::isInteractive%4B0D9A7A0096.get preserve=no
  return m_isInteractive;
  //## end PlotPkg::isInteractive%4B0D9A7A0096.get
}

inline void PlotPkg::isInteractive (bool value)
{
  //## begin PlotPkg::isInteractive%4B0D9A7A0096.set preserve=no
  m_isInteractive = value;
  //## end PlotPkg::isInteractive%4B0D9A7A0096.set
}

inline const std::vector<PlotStyle::VectorCategory>& PlotPkg::vectorCategories ()
{
  //## begin PlotPkg::vectorCategories%4AF98D27003E.get preserve=no
  return s_vectorCategories;
  //## end PlotPkg::vectorCategories%4AF98D27003E.get
}

//## Get and Set Operations for Associations (inline)

inline const std::vector<PlotPane*>& PlotPkg::plotPanes () const
{
  //## begin PlotPkg::plotPanes%4AE8B1850017.get preserve=no
  return m_plotPanes;
  //## end PlotPkg::plotPanes%4AE8B1850017.get
}

//## begin module%4AAE7FBD028E.epilog preserve=yes
//## end module%4AAE7FBD028E.epilog


#endif
